From 8d7e98ce1b77a4470a11e6aac054741d50427bf0 Mon Sep 17 00:00:00 2001
From: Rich Megginson <rmeggins@redhat.com>
Date: Wed, 1 Feb 2012 13:13:58 -0700
Subject: [PATCH] Ticket #87 - Manpages fixes

https://fedorahosted.org/389/ticket/87
Resolves: Ticket #87
Bug Description: Manpages fixes
Reviewed by: ???
Branch: master
Fix Description: Some hyphenation fixes that cause problems on some platforms.
Platforms tested: RHEL6 x86_64
Flag Day: no
Doc impact: no
---
 man/man1/cl-dump.1      |   18 +++++++++---------
 man/man1/dbgen.pl.1     |    4 ++--
 man/man1/infadd.1       |    8 ++++----
 man/man1/migratecred.1  |    6 +++---
 man/man1/mmldif.1       |    4 ++--
 man/man1/pwdhash.1      |    4 ++--
 man/man1/repl-monitor.1 |   16 ++++++++--------
 man/man8/ns-slapd.8     |   10 +++++-----
 man/man8/remove-ds.pl.8 |    6 +++---
 man/man8/setup-ds.pl.8  |    4 ++--
 10 files changed, 40 insertions(+), 40 deletions(-)

diff --git a/man/man1/cl-dump.1 b/man/man1/cl-dump.1
index 7a35aa2..68c541f 100644
--- a/man/man1/cl-dump.1
+++ b/man/man1/cl-dump.1
@@ -19,12 +19,12 @@
 cl-dump \- Dump and decode Directory Server replication change log
 .SH SYNOPSIS
 .B cl\-dump
-[\fI-h host\fR] [\fI-p port\fR] [\fI-D bind-dn\fR] -w bind-password | -P bind-cert
-       [\fI-r replica-roots\fR] [\fI-o output-file\fR] [\fI-c\fR] [\fI-v\fR]
+[\fI\-h host\fR] [\fI\-p port\fR] [\fI\-D bind\(hydn\fR] \-w bind\(hypassword | \-P bind\(hycert
+       [\fI\-r replica\(hyroots\fR] [\fI\-o output\(hyfile\fR] [\fI\-c\fR] [\fI\-v\fR]
 
 .PP
 .B cl\-dump
-\-i changelog\-ldif\-file\-with\-base64encoding [\fI\-o output\-file\fR] [\fI\-c\fR]
+\-i changelog\(hyldif\(hyfile\(hywith\(hybase64encoding [\fI\-o output\(hyfile\fR] [\fI\-c\fR]
 .PP
 .SH DESCRIPTION
 Dump and decode Directory Server replication change log
@@ -37,7 +37,7 @@ A summary of options is included below.
 .TP
 .B \-c 
 Dump and interpret CSN only. This option can be used with or
-without -i option.
+without \-i option.
 .TP
 .B \-D bind\-dn
 Directory server's bind DN. Default to "cn=Directory Manager" if
@@ -47,21 +47,21 @@ the option is omitted.
 Directory server's host. Default to the server where the script
 is running.
 .TP
-.B \-i changelog\-ldif\-file\-with\-base64encoding
+.B \-i changelog\(hyldif\(hyfile\(hywith\(hybase64encoding
 If you already have a ldif-like changelog, but the changes
 in that file are encoded, you may use this option to
 decode that ldif-like changelog.
 .TP
-.B \-o output\-file
+.B \-o output\(hyfile
 Path name for the final result. Default to STDOUT if omitted.
 .TP
 .B \-p port
 Directory server's port. Default to 389.
 .TP
-.B \-P bind\-cert
+.B \-P bind\(hycert
 Pathname of binding certificate DB
 .TP
-.B \-r replica\-roots
+.B \-r replica\(hyroots
 Specify replica roots whose changelog you want to dump. The replica
 roots may be separated by comma. All the replica roots would be
 dumped if the option is omitted.
@@ -69,7 +69,7 @@ dumped if the option is omitted.
 .B \-v 
 Print the version of this script.
 .TP
-.B \-w bind\-password
+.B \-w bind\(hypassword
 Password for the bind DN
 .SH RESTRICTIONS
 If you are not using \-i option, the script should be run when the server
diff --git a/man/man1/dbgen.pl.1 b/man/man1/dbgen.pl.1
index c53f2c8..efebb84 100644
--- a/man/man1/dbgen.pl.1
+++ b/man/man1/dbgen.pl.1
@@ -19,7 +19,7 @@
 dbgen.pl \- Random LDIF database creator
 .SH SYNOPSIS
 .B dbgen.pl
-[\fIOPTIONS\fR] -o output_file -n number 
+[\fIOPTIONS\fR] \-o output_file \-n number 
 .SH DESCRIPTION
 Random LDIF database creator.  Used to generate large LDIF files
 for use in testing the Directory Server.
@@ -81,4 +81,4 @@ for the Debian project (but may be used by others).
 This is free software.  You may redistribute copies of it under the terms of
 the Directory Server license found in the LICENSE file of this
 software distribution.  This license is essentially the GNU General Public
-License version 2 with an exception for plug-in distribution.
+License version 2 with an exception for plug\(hyin distribution.
diff --git a/man/man1/infadd.1 b/man/man1/infadd.1
index 36aa9c8..32570d7 100644
--- a/man/man1/infadd.1
+++ b/man/man1/infadd.1
@@ -19,7 +19,7 @@
 infadd \- infinite additions to LDAP server
 .SH SYNOPSIS
 .B infadd
-\fI-s suffix -u bindDN -w password \fR[\fIoptions\fR]
+\fI\-s suffix \-u bindDN \-w password \fR[\fIoptions\fR]
 .SH DESCRIPTION
 infadd is used
 to measure performance of the add operation. It can
@@ -38,13 +38,13 @@ port (default: 389)
 number of threads to spin (default: 1)
 .TP
 .B \-d
-use TCP no\-delay
+use TCP no\(hydelay
 .TP
 .B \-q
 quiet mode (no status updates)
 .TP
 .B \-v
-verbose mode (give per\-thread statistics)
+verbose mode (give per\(hythread statistics)
 .TP
 .B \-I num
 first uid (default: 0)
@@ -79,4 +79,4 @@ for the Debian project (but may be used by others).
 This is free software.  You may redistribute copies of it under the terms of
 the Directory Server license found in the LICENSE file of this
 software distribution.  This license is essentially the GNU General Public
-License version 2 with an exception for plug-in distribution.
+License version 2 with an exception for plug\(hyin distribution.
diff --git a/man/man1/migratecred.1 b/man/man1/migratecred.1
index d849ea1..3cc8232 100644
--- a/man/man1/migratecred.1
+++ b/man/man1/migratecred.1
@@ -20,7 +20,7 @@ migratecred \- Migrate credentials from one instance of Directory Server
 to another
 .SH SYNOPSIS
 .B migratecred 
--o OldInstancePath -n NewInstancePath -c OldCredential [\fI-p NewPluginPath\fR]
+\-o OldInstancePath \-n NewInstancePath \-c OldCredential [\fI\-p NewPluginPath\fR]
 .SH DESCRIPTION
 migratecred migrates credentials from one Directory Server instance to the other.
 
@@ -30,7 +30,7 @@ New plugin path defaults to [\fBlibdir\fP/dirsrv/plugins] if not given
 .\" \fI<whatever>\fP escape sequences to invode bold face and italics, 
 .\" respectively.
 \fBmigratecred\fP is a program that migrates credentials used for
-replication and chaining - that is, the password used by the server
+replication and chaining. That is the password used by the server
 to perform the simple BIND operation for server to server communications.
 .SH OPTIONS
 A summary of options is included below:
@@ -62,4 +62,4 @@ for the Debian project (but may be used by others).
 This is free software.  You may redistribute copies of it under the terms of
 the Directory Server license found in the LICENSE file of this
 software distribution.  This license is essentially the GNU General Public
-License version 2 with an exception for plug-in distribution.
+License version 2 with an exception for plug\(hyin distribution.
diff --git a/man/man1/mmldif.1 b/man/man1/mmldif.1
index 672accf..77aae9c 100644
--- a/man/man1/mmldif.1
+++ b/man/man1/mmldif.1
@@ -19,7 +19,7 @@
 mmldif \- mmldif util
 .SH SYNOPSIS
 .B mmldif
-[-c] [-D] [-o out.ldif] in1.ldif in2.ldif ...
+[\-c] [\-D] [\-o out.ldif] in1.ldif in2.ldif ...
 
 .SH DESCRIPTION
 This manual page documents briefly the
@@ -58,4 +58,4 @@ for the Debian project (but may be used by others).
 This is free software.  You may redistribute copies of it under the terms of
 the Directory Server license found in the LICENSE file of this
 software distribution.  This license is essentially the GNU General Public
-License version 2 with an exception for plug-in distribution.
+License version 2 with an exception for plug\(hyin distribution.
diff --git a/man/man1/pwdhash.1 b/man/man1/pwdhash.1
index 6014732..5b2d7d4 100644
--- a/man/man1/pwdhash.1
+++ b/man/man1/pwdhash.1
@@ -19,7 +19,7 @@
 pwdhash \- Generator of password hashes
 .SH SYNOPSIS
 .B pwdhash
-[\fI-D config-dir\fR] [\fI-H\fR] [\fI-s scheme | -c comparepwd\fR] password
+[\fI\-D config\(hydir\fR] [\fI\-H\fR] [\fI\-s scheme | \-c comparepwd\fR] password
 .PP
 .SH DESCRIPTION
 Generates password hashes which can also be used in LDIF password fields.
@@ -59,4 +59,4 @@ for the Debian project (but may be used by others).
 This is free software.  You may redistribute copies of it under the terms of
 the Directory Server license found in the LICENSE file of this
 software distribution.  This license is essentially the GNU General Public
-License version 2 with an exception for plug-in distribution.
+License version 2 with an exception for plug\(hyin distribution.
diff --git a/man/man1/repl-monitor.1 b/man/man1/repl-monitor.1
index e9abebd..424550e 100644
--- a/man/man1/repl-monitor.1
+++ b/man/man1/repl-monitor.1
@@ -18,13 +18,13 @@
 .SH NAME
 repl-monitor \- Directory Server replication monitor
 .SH SYNOPSIS
-.B repl-monitor
--f configuration-file [\fI-h host\fR] [\fI-p port\fR] [\fI-r\fR] 
-[\fI-u refresh-url\fR] [\fI-t refresh-interval\fR] [\fI-v\fR]
+.B repl\(hymonitor
+\-f configuration\(hyfile [\fI\(hyh host\fR] [\fI\-p port\fR] [\fI\-r\fR] 
+[\fI\-u refresh\(hyurl\fR] [\fI\-t refresh\(hyinterval\fR] [\fI\-v\fR]
 
 .SH DESCRIPTION
 Outputs the status of all of the configured Directory Servers
-participating in replication.  The servers to query for status
+participating in replication. The servers to query for status
 are specified in the configuration file.
 .PP
 .\" TeX users may be more comfortable with the \fB<whatever>\fP and
@@ -39,16 +39,16 @@ Hostname of DS server
 .B \-p port
 TCP port
 .TP
-.B \-f configuration\-file
+.B \-f configuration\(hyfile
 Configuration file 
 .TP
 .B \-r
 Removes extra HTML tags
 .TP
-.B \-u refresh\-url
+.B \-u refresh\(hyurl
 Refresh url
 .TP
-.B \-t refresh\-interval
+.B \-t refresh\(hyinterval
 Refresh interval
 .br
 .SH AUTHOR
@@ -66,4 +66,4 @@ for the Debian project (but may be used by others).
 This is free software.  You may redistribute copies of it under the terms of
 the Directory Server license found in the LICENSE file of this
 software distribution.  This license is essentially the GNU General Public
-License version 2 with an exception for plug-in distribution.
+License version 2 with an exception for plug\(hyin distribution.
diff --git a/man/man8/ns-slapd.8 b/man/man8/ns-slapd.8
index fb1386a..2f88281 100644
--- a/man/man8/ns-slapd.8
+++ b/man/man8/ns-slapd.8
@@ -16,12 +16,12 @@
 .\" .sp <n>    insert n+1 empty lines
 .\" for manpage-specific macros, see man(7)
 .SH NAME
-ns-slapd \- The main Directory Server daemon
+ns\(hyslapd \- The main Directory Server daemon
 .SH SYNOPSIS
 .B ns-slapd
--D configdir [\fI-d debuglevel\fR] [\fI-i pidlogfile\fR] [\fI-v\fR] [\fI-V\fR]
+\-D configdir [\fI\-d debuglevel\fR] [\fI\-i pidlogfile\fR] [\fI\-v\fR] [\fI\-V\fR]
 .SH DESCRIPTION
-ns-slapd launches the LDAP Directory Server 
+ns\(hyslapd launches the LDAP Directory Server 
 .PP
 .\" TeX users may be more comfortable with the \fB<whatever>\fP and
 .\" \fI<whatever>\fP escape sequences to invode bold face and italics, 
@@ -34,7 +34,7 @@ Show version of program.
 .TP
 .B \-D configdir
 Specifies the configuration directory pointing at the instance
-to be started (e.g. /etc/dirsrv/slapd-localhost)
+to be started (e.g. /etc/dirsrv/slapd\(hylocalhost)
 .TP
 .B \-d debuglevel
 Specifies the debuglevel to be used 
@@ -57,4 +57,4 @@ for the Debian project (but may be used by others).
 This is free software.  You may redistribute copies of it under the terms of
 the Directory Server license found in the LICENSE file of this
 software distribution.  This license is essentially the GNU General Public
-License version 2 with an exception for plug-in distribution.
+License version 2 with an exception for plug\(hyin distribution.
diff --git a/man/man8/remove-ds.pl.8 b/man/man8/remove-ds.pl.8
index e8e322a..3bcf1e0 100644
--- a/man/man8/remove-ds.pl.8
+++ b/man/man8/remove-ds.pl.8
@@ -37,10 +37,10 @@ A summary of options is included below:
 Force removal
 .TP
 .B \fB\-d\fR
-Enable debugging - adding more -d will make output more verbose
+Enable debugging: adding more \-d will make output more verbose
 .TP
 .B \fB\-i\fR \fIinstance\fR
-The full name of the instance to remove (e.g. slapd-example)
+The full name of the instance to remove (e.g. slapd\(hyexample)
 .br
 .SH AUTHOR
 remove-ds.pl was written by the 389 Project.
@@ -52,4 +52,4 @@ Copyright \(co 2009 Red Hat, Inc.
 This is free software.  You may redistribute copies of it under the terms of
 the Directory Server license found in the LICENSE file of this
 software distribution.  This license is essentially the GNU General Public
-License version 2 with an exception for plug-in distribution.
+License version 2 with an exception for plug\(hyin distribution.
diff --git a/man/man8/setup-ds.pl.8 b/man/man8/setup-ds.pl.8
index e7eccc3..6c326a4 100644
--- a/man/man8/setup-ds.pl.8
+++ b/man/man8/setup-ds.pl.8
@@ -56,7 +56,7 @@ Do not delete the temporary .inf file generated by this program
 Log setup messages to this file \- otherwise, a temp file will be used
 .TP
 .B \fB\-\-update\fR
-Update existing installations - add/update schema files, add/change configuration, add new instance scripts, etc. You must run setup-ds.pl -u after upgrading your packages.  You will usually have to restart your servers in order for all of the changes to take effect (e.g. adding/changing plug-in configuration), so schedule this when you can afford a little downtime.
+Update existing installations \- add/update schema files, add/change configuration, add new instance scripts, etc. You must run setup-ds.pl \-u after upgrading your packages.  You will usually have to restart your servers in order for all of the changes to take effect (e.g. adding/changing plug-in configuration), so schedule this when you can afford a little downtime.
 .TP
 .B \fB\-\-continue\fR
 (Update only) Keep going even if errors occur.  You will usually not need to use this option unless your installation is broken and you need to force it to update in order to fix it.
@@ -79,7 +79,7 @@ or
 .PP
 Values passed in this manner will override values in an .inf file given with the \fB\-f\fR argument.
 .SH UPDATES
-The update process (setup-ds.pl -u) can work in one of two modes:
+The update process (setup-ds.pl \-u) can work in one of two modes:
 
 \fBOnline\fR: Configuration changes are made to the running directory servers
 using LDAP.  The operations must be performed as an administrative
-- 
1.7.1